// game.cpp

// Includes
#include "Saucer.h"
#include "Hero.h"
#include "Star.h"
#include "GameStart.h"
#include "GameManager.h"
#include "LogManager.h"
#include "ResourceManager.h"

// Function prototypes
void loadResources(void);
void populateWorld(void);

int main(int argc, char *argv[]) 
{

  LogManager &log_manager = LogManager::getInstance();

  // Start up Game Manager
  GameManager &game_manager = GameManager::getInstance();
  
   if (game_manager.startUp())  
   {
    	game_manager.shutDown();
   }
 
  loadResources(); 
  populateWorld();
  game_manager.run();
  game_manager.shutDown();

}

//load up sprites and other game assets
void loadResources(void) {
  ResourceManager &resource_manager = ResourceManager::getInstance();
  resource_manager.loadSprite("sprites/saucer-spr.txt", "saucer");
  resource_manager.loadSprite("sprites/ship-spr.txt", "ship");
  resource_manager.loadSprite("sprites/bullet-spr.txt", "bullet");
  resource_manager.loadSprite("sprites/explosion-spr.txt", "explosion");
  resource_manager.loadSprite("sprites/gamestart-spr.txt", "gamestart");
  resource_manager.loadSprite("sprites/gameover-spr.txt", "gameover");
}

// Create stars and instantiate GameStart Obj.
void populateWorld(void) {

  for (int i=0; i<20; i++)
  {
    new Star;
  }
  
  string temp = "gamestart";

  new GameStart(temp);
}

